\documentclass{llncs}
%
\usepackage{makeidx}  % allows for indexgeneration
\usepackage{epsfig}
\usepackage{varioref}
%
\begin{document}
%
\frontmatter          % for the preliminaries
%
\pagestyle{headings}  % switches on printing of running heads
\addtocmark{Hamiltonian Mechanics} % additional mark in the TOC
%
% second contribution with nearly identical text,
% slightly changed contribution head (all entries
% appear as defaults), and modified bibliography
%
\title{Imitation as a mean of learning in AI}

\author{Tobias Nielsen}


\institute{University of Southern Denmark, M\ae rsk Institute, 
Campusvej 55,
5230 Odense M, 
Denmark}

\pagestyle{empty}  % switches on printing of running heads

\maketitle
%
% Modify the bibliography environment to call for the author-year
% system. This is done normally with the citeauthoryear option
% for a particular contribution.
\makeatletter
\renewenvironment{thebibliography}[1]
     {\section*{\refname}
      \small
      \list{}%
           {\settowidth\labelwidth{}%
            \leftmargin\parindent
            \itemindent=-\parindent
            \labelsep=\z@
            \if@openbib
              \advance\leftmargin\bibindent
              \itemindent -\bibindent
              \listparindent \itemindent
              \parsep \z@
            \fi
            \usecounter{enumiv}%
            \let\p@enumiv\@empty
            \renewcommand\theenumiv{}}%
      \if@openbib
        \renewcommand\newblock{\par}%
      \else
        \renewcommand\newblock{\hskip .11em \@plus.33em \@minus.07em}%
      \fi
      \sloppy\clubpenalty4000\widowpenalty4000%
      \sfcode`\.=\@m}
     {\def\@noitemerr
       {\@latex@warning{Empty `thebibliography' environment}}%
      \endlist}
      \def\@cite#1{#1}%
      \def\@lbibitem[#1]#2{\item[]\if@filesw
        {\def\protect##1{\string ##1\space}\immediate
      \write\@auxout{\string\bibcite{#2}{#1}}}\fi\ignorespaces}
\makeatother
%
\begin{abstract}
  Imitation is the method we use to learn by observing a teacher and
  repeating the shown action. In this article I give an introduction
  to how humans and other primates supports imitation as a mean of
  learning. A few methods of building an imitation system where I
  focus mainly on active and passive learning from imitation and also
  on the mapping between young infants and a facial robot.

%% The abstract should summarize the contents of the paper
%% using at least 70 and at most 150 words. It will be set in 9-point
%%font size and be inset 1.0 cm from the right and left margins.
%% There will be two blank lines before and after the Abstract. \dots
\end{abstract}
%
\section*{We are not alone}
We are not alone! During our growth we have been socially adapted by
the people that we live among and by them taught how to interact with
our surroundings. We observe peoples behavior and to some extend learn
from this behavior to shape our own personality. This has been largely
due to classical reinforcement methods that are used learning people
from the smallest child stages to grown up stage. But it is also
largely due to the individuals ability to observe an action and repeat
the shown action \dots imitation.

This imitation ability has until recently only been thought to exists
in humanoids, but science is now showing that these behaviors is also
observed in animals at different levels. Here the closest mammal to
the human race, the chimpanzee, is a typical example of a species that
is able to reproduce this behavior.

The basis for imitation is the ability to perceive a behavior and
match it with a somewhat internal equivalent behavior in the body of
the observer. This may include a somewhat peculiar mapping since the
kinematic model of the individuals may differ to such a level that
reproduction of the action may simply be unfeasible for its topoligy.

\subsection*{The robotics}
So why is imitation such an interesting topic in the robotics domain? 

Programming a robot is often considered a complex task which needs to
be verified repeatedly against the environment that it lives within.
This is time consuming and will automatically cost at least one person
that must use expensive time to program the robot and often also needs
to have extensive knowledge on how to operate the robot. With
imitation the ``programmer'' can continue performing his work and let
the robot imitate him - gradually learning the task at hand. Or, we
could instead let the robot learn from other robots that allready is
able to perform a simular task.

Letting a robot be equipped with imitation abilities, gives the
possibility to let it learn a task from a teacher with a completely
different layout. This is off course a peculiar ability since the
robot may not at all be able to execute the task, that it has perceived,
due to constraints in the physical design. (eg. speed, force, degrees of
freedom, etc..) It is argumented by [\cite{gillianHayes}] that
imitation in robots gives opportunity to bypass the situation where
its impossible to copy two identical programs from one robot to
another since the robots sensory and motory system differ even though
they may be equal in architecture.

\section{Outline}
Shortly, the article will include these topics:

\begin{itemize}
\item First I will try to lay out what is actually meant when I
  discuss the term imitation. This will give an overview of the states
  a human person walks through when he/she progresses through its
  initials stages in life.
\item A focus on how imitation is going on on the neural level. It is 
  shown that humans and certain animals seems to have a specific kind
  of neurons that is very important when it comes to learning from our
  surroundings.
\item A description of the passive architecture for learning as
  described by \cite{yannis}. He describes very deepening how the
  destination between the passive architecture that is based on the
  idea that the perceiver goes trough a ``perceive $\rightarrow$
  recognize $\rightarrow$ reproduce'' sequence. In this system the
  motorical system (limbs) are only included in the final face. 

  Secondly he describes the active imitation model which includes
  involving the motorical system already from the perceive fase.

\item When passive imitation, which is the base of the imitation model
  that is discussed here, doesn't fit because it lacks the ability to
  optimize and learn new skills - an additional model must be
  utilized. This opens up the possibility for the system to memorize
  new features.

\item A basic simulation is being present that shows mainly the base
  idea in passive imitation and also arguments its usability. It also
  shortly introduce mapping of new behaviors by applying active
  imitation.

\item To show the usefulness of a robot that is able to learn from
  another robot - a small experiment is being discussed to show how a
  demonstrator robot can guide an imitating robot around a maze,
  teaching it to find its own ways through the maze. This robot uses
  the idea that its solely responsible for self calibration of its own
  sensory and actuator systems; a feature that is important since no
  two robots are similar even though thier design is the same. Two
  reach the extreme of this idea, the two robots are completely
  different from each other in design.

\item The final step is trying to map the ability of a young child to
  a robot that will reproduce the demonstrators facial impressions.
  This is done in two steps. The first is just imitating the behavior
  it instinctively sees and the next abstracts the behaviors by
  actually storing the facial expressions trying to produce them at a
  later time.
\end{itemize}

\subsection{Imitation in natural systems}
A lot of research has been conducted in understanding imitation in
biological systems and much is yet still to be analyzed and
understood.  From [\cite{gillianHayes}] two questions is raised that
asks mainly \emph{what is imitation} and \emph{which animals can do
  imitation} These is a topic that seems to newer reach its closure and
therefore has wide disagreements in either directions. As its mentioned
by [\cite{gillianHayes}], a lot of different animals has shown certain
imitation like abilities that cannot be discarded as \emph{not} being
imitation.

Humans has shown to use a very sophisticated model that is of
particular interest in the earlier stages of life. According to
[Piaget, 1975] as stated in [\cite{gillianHayes}], infants starts
their life being able to reproduce behaviors where the actions of the model
and the infant can be compared. This continues when the infant reach
the first year where he is able to see the equivalence that will mean
that its able to reproduce facial movements that it is not able to
directly perceive visualy on the infants own body.  After about 18-24 months,
it reaches a level where its able to reproduce movements that are not
within the perceptual view and therefore memorizes behaviours.

This part has also been discussed, arguing that infants are born with
a basic repository of actions that it can execute. Therefore it do not
have the ability to perform imitation before it has reached a somewhat
older and more sophisticad state in its brain.


%% --------- im at this point in the review.

\subsection{The neural level of imitation}
\cite{yannis} describes how several studies has been made of the
interplay between action generation and action perception. This has
shown how this can be produce reflections in several parts of the
brain. There was shown a serious amount of motor invoked potentials
(MEPs) from different parts of the had appeared when an action was
perceived. When the action was to be reproduced, it showed that a
large amount of MEPs was utilized in the same manner. This indicated
that the motor system was included in many cases where imitation was
to occur.

\cite{yannis} states also that during an interesting experiment, a
series of persons was instructed to perceive movements of a virtual
reality hand grasping an object or to imagine their own hand grasping
objects- presented through a virtual reality system.

This showed that a lot of the same brain groups was activated during
both imagination and observation of the hand. This lead to conclusion
that further augmented for the fact that the motory system was
implemented in a large part of the imitation process.

\subsubsection{Mirror neurons}
Several experiments conducted on monkeys have shoved that a special
class of neurons exist in the brain. These neurons gets activated when
the monkey both executes a goal-oriented movement and when it observes
the demonstrator of similar movements executed by humans or another
monkey. 
A lot of neurons with different mappings was revealed:
Grasping,tearing, manipulation,  placing etc. Some of these neurons was
active only when during the demonstration while others was active
sometime after the demonstration was completed.

A lot of these neurons is directly mapped to the concrete action while
others is sensitive to the context they appear in.

But especially interesting in this domain was that non-biological
stimuli didn't cause the neurons to activate. This showed that only
actions that was feasible with the body available was being
represented by this neural network.

\subsubsection{Brain disorder}
Imitation is a very complex task since it utilizes many parts of the
brain like perception, memory and motory systems. This is therefore
often used as a mean to identify different kinds of brain
disorders. This can for instance be seen in a specific disorder called
apraxia \emph{(visuo-imitative apraxia)} where the patient is able to
perform meaningful gestures when they are described to them verbally
but are unable to present meaningless gestures\dots

\subsection{Passive imitation}
There is a lot of potential in leaning from imitation and these was
recognized by early robotics scientist as described by \cite{yannis}

The idea for passive imitation is based on the idea of a topic called
``active intermodal mapping'' where the observer perceives the
teachers action as a target to which it will direct its own limps (also
called body states) 

\cite{yannis} has presented an  architecture for passive stimuli as
presented in figure \vref{fig:passive}. In this model the posture is fed from
the perception system to the estimator that extracts information in
form of angles and end poses.  This information is stored after having
being filtered to a useful information level. From here an target
position is extracted and fed forward to the matching module that
selects a proper movement command that is feed to the actuators and
executed. 

\begin{figure}[t]
\centering
\epsfig{file=passive-imitation.eps,width=0.7\linewidth}
\caption{Architecture proposed by \cite{yannis}}\label{fig:passive}
\end{figure}

In the matching posture module, a serious of known postures is matched
against the perceived posture and the selection of the posture is
based on the amount of fitness the posture receives in the matching
process. 

The consequence of this architecture demonstrates that as long as
there is knowledge representing the possible poses - the architecture
performs well.

But is it a feasible solution for explaining imitation in early
infants? \cite{yannis} arguments that its highly unlikely that a child
should have such predefined knowledge that could act as a base library
at this early stage for posture recognition.

Its also a drawback that this method is solely based on an known set
of postures since it leaves no possibility of optimizing the postures
as they are being selected.

\subsection{Active imitation}
In order to repair the disadvantages from the passive imitation
architecture, the active imitation model has been proposed also by
\cite{yannis}  This method is based on forward models where the robot
tries to maintain a small errors when it compares its own predicted
position with the perceived position and by using reinforcement
learning updates the poses accordingly.

The active imitation is an addition to the passive imitation method
meaning that it will only activate its ability of learning new poses
if the passive method fails. The indication of a failure in the
passive system is due to a low score in fitting the posture with any
of its previously know postures.

When the posture is learned to a sufficient level, its inserted in to
the posture repository and updated each time its presented with the
new posture.
This also means that all other poses is each time being updated
accordingly to the perceived posture. This gives the advantage that a
robot will adapt to the peculiarities of the specific platforms
sensors and actuators.

In order to reach a feasible solution for this, \cite{yannis} propose
a series of different feed forward and/or inverse methods that is
based on common control logic.

\subsection{Simulation of imitation}
In order to experiment with implementing a passive imitation method, a
program has been constructed by \cite{yannis} and \cite{gillianHayes}
that shows both a demonstrator and a imitator. The imitator has a
series of possible end poses to select from and by trying to fit these
poses with the perceived demonstrator.

The robot simulation is done to such an extend that it simulates the
forces since its an important factor since the robot uses the motory
system to reflect the poses needed in building the different poses.
 
\begin{figure}[t]
\centering
\epsfig{file=simulator.eps,width=0.7\linewidth}
\caption{Visualization of simulator to describe passive imitation}
\end{figure}

The method appears to perform well for the simulated system but still
lacks the ability to obtain the poses if the pose is not known to the
imitator prior to the display of the pose.

This leads the next step where active imitation is used to learn a new
pose.



\subsection{Mobile robots by imitation}
Another very interesting project was conducted Gillian Hayes and John
Demiris (Yiannis Demires) where they in
\cite{gillianHayes} describe how they have made
demonstrator robot that will show how to move through a maze (with
only one way all the time) A imitator robot follows right behind the
demonstrator and learn how to interpret the environment based on the
demonstrator. The interesting part is the fact that the robots is
quite different from each other and therefore the demonstrator is
dependent on its ability to learn the different sensory inputs that
triggers the action that the imitator has to execute the equivalent
action. 

\begin{figure}
\centering
\epsfig{file=car.eps,width=0.8\linewidth}
\caption{Picture of demonstrator car as seen by the imitator}
\end{figure}

Such a robot also opens up for a new problem, the visual perception
of the demonstrator robot. The project was presented during 1994 by
which time the available processor power to conduct a reasonable
amount of vision math was fairly limited. Therefor the demonstrator
robot was equipped with LEDs that could be filtered to a simple binary
image that was easy to analyze.

Another thing that was also learned from this was that the robot
needed to tell the perceiver when a significant event occurred. This
demanded the need for the two robots to communicate a sort of ``watch
me'' command. This is in principle not a true necessity - but using
this indication of important events reduces the complexity of the
system. 

The system did not reach a closure point in
\cite{gillianHayes} due to time constraints, but in a
later article \cite{imitative-learning} it was concluded that the
system had worked. 

In order to test the learned abilities, the resulting robot (the
imitator) was placed in a new maze where it managed to use its new
learned abilities to navigate through the maze. This showed the
ability of the system to let robots learn from each other.


\subsection{Imitation of Human head movements}
The final step I will present the context of
\cite{imitative-learning}, is imitation in order to do socialistic
behaviors with human movements of a human head. This kind of
behaviors gives the robot the possibility to represent a method for
achieve human like appearances like an infant in its 1 year stage
where its able to reproduce the facial poses of a demonstrator.

But this also puts higher demands on the perception of the
demonstrator as it is now not possible to simplify as far as been done
by the follower robot presented earlier. To represent the perceptional
system, a neural network was applied that can present the different
features of an arbitrary face.

\begin{figure}
\centering
\epsfig{file=neural.eps,width=0.4\linewidth}
\caption{Recognition of head using a BP-trained neural
  net}\label{fig:bp-net} 
\end{figure}

The image is then perceived by either locating external observable
characteristics or regions where movement is taking place. This is
then transfered in to a field that describes the error for the present
face and is from that able to correct its features - see
figure \vref{fig:bp-net} 

\begin{figure}
\centering
\epsfig{file=see-me.eps,width=0.4\linewidth}
\caption{deferred imitation by stereo head}\label{fig:deferred}
\end{figure}

The second part \cite{deferred-imitation}. Is focusing on the later
state in the young infants life where deferred action is being
conducted. This means that robot is able to use memory to store the
perceived information for later use. This is of high interest since
it brings imitation to the level we are seeing in humans. (see figure
\vref{fig:deferred}) 

\section*{Conclusion and discussion}
In this article I have presented the basis for imitation. I have shown
how to use imitation in both passive and active domains while
referring to active projects that uses these methods.

It is clear that in implementing a imitation system, the perception
system may introduce a advanced bottleneck. This is off course a thing
that will be easier as the amount of processing power increases - but
it still demands considerable effort as shown by
\cite{imitative-learning} where they use neural networks to perceive
the demonstrator. 
But there are also many scenarios that can be used to a much simpler
extend where the perception is being performed by placing easy
detectable markers as seem with \cite{gillianHayes}.

\section*{Acknowledgments}
This article has been written at the M\ae rsk McKinney M\oe ller
institute of Southern Danish University. The author wishes to thank
Gillian Hayes for giving input to useful materials in this
article. It must also be noted that is was due to John Hallam that
this topic was initially chosen.

%
% ---- Bibliography ----
%
\begin{thebibliography}{}
%

\bibitem[(Demires, Y., Hayes, G. 2002)]{yannis}
Demires, Y., Hayes, G.:
Imitation as a dual-route process featuring predictive and learning
components: a biologically-plausible computational model.
chapter 13, pp. 327-361, in ``Imitation in Animals and Artifacts'',
edited by K. Dautenhahn and C. Nehaniv, MIT Press, 2002 

\bibitem[(Hayes, G., Demiris,J. 1994)]{gillianHayes}
Hayes, G., Demiris,J.:
A Robot Controller Using Learning By Imitation.
Proceedings of the 2nd International Symposium on Intelligent Robotic
Systems, pp. 198-204, Grenoble, France, July 1994 

\bibitem[(Demiris, Hayes 1996)]{imitative-learning}
J. Demiris and G. Hayes:
Imitative Learning Mechanisms in Robots and Humans  J. Demiris and
G. Hayes,  Department of Artificial Intelligence Research Paper No
814,  published in the  Proceedings of the 5th European Workshop on
Learning Robots, , pp. 9-16, Bari, Italy, July 1996. 

\bibitem[(Demiris, Rougeaux, Hayes, Berthouze 1997)]{deferred-imitation}
Deferred Imitation of Human Head Movements by an Active Stereo Vision
Head  J. Demiris, S. Rougeaux, G. M. Hayes, L. Berthouze, and
Y. Kuniyoshi,  Proceedings of the 6th IEEE International Workshop on
Robot Human Communication,  pp. 88-93, IEEE Press, Sendai, Japan,
Sept. 1997. 

%% \bibitem[1980]{2clar:eke}
%% Clarke, F., Ekeland, I.:
%% Nonlinear oscillations and
%% boundary-value problems for Hamiltonian systems.
%% Arch. Rat. Mech. Anal. {\bf 78} (1982) 315--333

%% \bibitem[1981]{2clar:eke:2}
%% Clarke, F., Ekeland, I.:
%% Solutions p\'{e}riodiques, du
%% p\'{e}riode donn\'{e}e, des \'{e}quations hamiltoniennes.
%% Note CRAS Paris {\bf 287} (1978) 1013--1015

%% \bibitem[1982]{2mich:tar}
%% Michalek, R., Tarantello, G.:
%% Subharmonic solutions with prescribed minimal
%% period for nonautonomous Hamiltonian systems.
%% J. Diff. Eq. {\bf 72} (1988) 28--55

%% \bibitem[1983]{2tar}
%% Tarantello, G.:
%% Subharmonic solutions for Hamiltonian
%% systems via a $\bbbz_{p}$ pseudoindex theory.
%% Annali di Matematica Pura (to appear)

%% \bibitem[1985]{2rab}
%% Rabinowitz, P.:
%% On subharmonic solutions of a Hamiltonian system.
%% Comm. Pure Appl. Math. {\bf 33} (1980) 609--633

\end{thebibliography}
\clearpage
\addtocmark[2]{Author Index} % additional numbered TOC entry
\renewcommand{\indexname}{Author Index}
\printindex
\clearpage
\addtocmark[2]{Subject Index} % additional numbered TOC entry
\markboth{Subject Index}{Subject Index}
\renewcommand{\indexname}{Subject Index}

\end{document}